/* 
 *  AudioPlayback.h
 *
 *	Copyright (C) Alberto Vigata - January 2000 - ultraflask@yahoo.com
 *
 *  This file is part of FlasKMPEG, a free MPEG to MPEG/AVI converter
 *	
 *  FlasKMPEG is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  FlasKMPEG is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */

#ifndef AUDIO_PLAYBACK_H
#define AUDIO_PLAYBACK_H

struct TAudioPlayback
{
	int n_channels;
	int sample_freq;
	int chunk_size;  // Size of audio data when calling AudioPlaybackWrite
};


int AudioPlaybackStart(TAudioPlayback *ap);
int AudioPlaybackWrite(TAudioPlayback *ap, unsigned char *data);
int AudioPlaybackStop(TAudioPlayback *ap);
int AudioGetBufferDelay(TAudioPlayback *ap);
int AudioPlayBackReset();

#endif