/* 
 *  tables.h
 *
 *	Copyright (C) Alberto Vigata - July 2000  ultraflask@yahoo.com
 *                 
 *
 *  This file is part of FlasKMPEG, a free MPEG to MPEG/AVI converter
 *	
 *  FlasKMPEG is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  FlasKMPEG is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */


#define RESERVED 1
static double MPEG1aspect_ratio_Table[16] =
{
	0.0,    
	1.0000,
	0.6735,		
	0.7031,
	0.7615,		
	0.8055,		
	0.8437,
	0.8935,		
	0.9375,
	0.9815,		
	1.0255,		
	1.0695,		
	1.1250,
	1.1575,		
	1.2015,
	RESERVED
};

static double frameRateTable[16]=
{
  0.0,
  (24000.0/1001.0),
  24.0,
  25.0,
  (30000.0/1001.0),
  30.0,
  50.0,
  (60000.0/1001.0),
  60.0,
  0.0,
  0.0,
  0.0,
  0.0,
  0.0,
  0.0,
  0.0
};


static long frame_rate_scale_table[16]=
{
    0,  23976, 24,  25,  2997,  30,  50,  5994,
    60, 0,     0,    0,     0,   0,   0,     0
};

static long frame_rate_scale_samplesize[16]=
{
    0,  1000,   1,    1,  100,   1,   1,   100,
    1,     0,   0,    0,    0,   0,   0,     0
};

static double MPEG2aspect_ratio_Table[16] =
{
  0.0,
  1,
  (3.0/4.0),
  (9.0/16.0),
  (1.0/2.21),
  RESERVED,
  RESERVED,
  RESERVED,
  RESERVED,
  RESERVED,
  RESERVED,
  RESERVED,
  RESERVED,
  RESERVED,
  RESERVED,
  RESERVED
};

