/* 
 *  flbrightness.h   
 *           
 *
 *	Copyright (C) Alberto Vigata - January 2000
 *
 *  This file is part of FlasKMPEG, a free MPEG to MPEG/AVI converter
 *	
 *  FlasKMPEG is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  FlasKMPEG is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */


#ifndef FLBRIGHTNESS_H
#define FLBRIGHTNESS_H

#include "FlFilterSimple.h"

static const int g_nBrightnessMin = 0;
static const int g_nBrightnessMax = 255;

struct TBrightnessCfg
{
  int brightness; //
  int hue;
  int contrast;
};

#define IsValidCropConfig(x)

class FlBrightness : public FlFilterSimple
{
public:
  FlBrightness();
  int StartSimple();
  int Configure(void *conf, int confsize );
  int GetFilterConf( flfilter_conf *fc );
  int ValFilterConf( flfilter_conf *fc );
  int ProcessSimple(CFrame *in, CFrame *out);
  int StopSimple();

private:
  void Luminance(CFrame *in);
  TBrightnessCfg m_cfg;
};



#endif